org.apache.storm.solr.bolt

## Class SolrUpdateBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.topology.base.BaseTickTupleAwareRichBolt
      - - org.apache.storm.solr.bolt.SolrUpdateBolt

- All Implemented Interfaces:
    Serializable, IBolt, IComponent, IRichBolt

      public class SolrUpdateBolt
      extends BaseTickTupleAwareRichBolt

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SolrUpdateBolt(SolrConfig solrConfig, SolrMapper solrMapper)`
    `SolrUpdateBolt(SolrConfig solrConfig, SolrMapper solrMapper, SolrCommitStrategy commitStgy)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cleanup()` Called when an IBolt is going to be shutdown.
    `void` | `declareOutputFields(OutputFieldsDeclarer declarer)` Declare the output schema for all the streams of this topology.
    `Map<String,Object>` | `getComponentConfiguration()` Declare configuration specific to this component.
    `void` | `prepare(Map<String,Object> topoConf, TopologyContext context, OutputCollector collector)` Called when a task for this component is initialized within a worker on the cluster.
    `protected void` | `process(Tuple tuple)` Process a single non-tick tuple of input.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseTickTupleAwareRichBolt

      `execute, onTickTuple`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SolrUpdateBolt

          public SolrUpdateBolt(SolrConfig solrConfig,
                                SolrMapper solrMapper)

    - #### SolrUpdateBolt

          public SolrUpdateBolt(SolrConfig solrConfig,
                                SolrMapper solrMapper,
                                SolrCommitStrategy commitStgy)

  - ### Method Detail

    - #### prepare

          public void prepare(Map<String,Object> topoConf,
                              TopologyContext context,
                              OutputCollector collector)

      Description copied from interface: `IBolt`

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Parameters:
        `topoConf` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### process

          protected void process(Tuple tuple)

      Description copied from class: `BaseTickTupleAwareRichBolt`

      Process a single non-tick tuple of input. Implementation needs to handle ack manually. More details on `IBolt.execute(Tuple)`.

      Specified by:
        `process` in class `BaseTickTupleAwareRichBolt`
      Parameters:
        `tuple` - The input tuple to be processed.

    - #### getComponentConfiguration

          public Map<String,Object> getComponentConfiguration()

      Description copied from interface: `IComponent`

      Declare configuration specific to this component. Only a subset of the “topology.*” configs can be overridden. The component configuration can be further overridden when constructing the topology using `TopologyBuilder`

      Specified by:
        `getComponentConfiguration` in interface `IComponent`
      Overrides:
        `getComponentConfiguration` in class `BaseComponent`

    - #### declareOutputFields

          public void declareOutputFields(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`

      Declare the output schema for all the streams of this topology.

      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`

      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`
      Overrides:
        `cleanup` in class `BaseRichBolt`

Copyright © 2021 The Apache Software Foundation. All rights reserved.